
package xelfi.browser.document;

import xelfi.editor.Position;
import xelfi.editor.Document;
import xelfi.editor.EndOfTextException;
import xelfi.editor.InvalidPositionException;
import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.IOException;

public class MyPosition
{
    protected int line;
    protected int column;
    protected Position position = null;

    public MyPosition(int pLine,int pColumn)
    {
        line = pLine;
        column = pColumn;
    }
    public MyPosition(Position p)
    {
        position = p;
    }
    void open(Document d)
    {
        try{
            position = d.goToLine(line);
            position = position.column(column);
        }catch(EndOfTextException e)
        {
            System.out.println("MyPosition error 124");
        }
    }
    void close() //throws InvalidPositionException
    {
        line = position.getDocument().lineToInt(position);
        column = position.getColumn();
        position = null;
    }
    public Position getPosition()
    {
        return position;
    }
    int getLine()
    {
        if( position == null )
            return line;
        else
            return position.getDocument().lineToInt(position);
    }
    int getColumn()
    {
        if( position == null )
            return column;
        else
            return position.getColumn();
    }
    static void write(MyPosition p,DataOutputStream os)
        throws IOException
    {
        if( p == null )
        {
            os.writeChar(0);
        }else
        {
            os.writeChar(p.getLine() + 1);
            os.writeChar(p.getColumn());
        }
    }
    static MyPosition read(DataInputStream is)
        throws IOException
    {
        int l = is.readChar();
        if( l == 0 )
            return null;
        else
            return new MyPosition(l - 1,is.readChar());
    }


}




