
package xelfi.browser.view;

import xelfi.browser.util.*;
import xelfi.browser.document.*;
import xelfi.editor.Source;
import xelfi.editor.Position;
import xelfi.editor.Block;
import xelfi.editor.NotAllowedException;
import xelfi.editor.EndOfTextException;
import xelfi.editor.InvalidPositionException;
import xelfi.xedit.JavaEditorFrame;
import xelfi.top.TopLevel;

import java.awt.*;
import java.io.IOException;


public class MemberView extends xelfi.top.TopDialog
   implements modalObject
{

    BrMember    member;
    boolean     methodView;
    Dialog      d;

    public MemberView(Frame parent,BrMember pMember) {

       super(parent, "Member view", false);
        member = pMember;
        Modifiers m = member.modifiers;;
        if( member instanceof BrMethod )
            methodView = true;
        else
            methodView = false;

        addNotify();
        resize(insets().left + insets().right + 2, insets().top + insets().bottom + 8);

        setLayout(new HorizLayout(HorizLayout.RESIZE,HorizLayout.CENTER));
        group1= new CheckboxGroup();

        panel2=new Panel();
        panel2.setLayout(new VertLayout(VertLayout.CENTER,VertLayout.TOP));

        panel3=new Panel();
        panel3.setLayout(new HorizLayout(HorizLayout.LEFT,HorizLayout.TOP));

        Panel panel;
        if( methodView )
        {
            BrMethod mm = (BrMethod)member;

            setTitle("Metod " + member.object.getNameWithPackage() +
                "." + member.name);

            chAbstract = new Checkbox("Abstract");
            chAbstract.setState(m.abstractM());
            panel3.add(chAbstract);
            chStatic = new Checkbox("Static");
            chStatic.setState(m.staticM());
            panel3.add(chStatic);
            chFinal = new Checkbox("Final");
            chFinal.setState(m.finalM());
            panel3.add(chFinal);
            chNative = new Checkbox("Native");
            chNative.setState(m.nativeM());
            panel3.add(chNative);
            chSynchronized = new Checkbox("Synchronized");
            chSynchronized.setState(m.synchronizedM());
            panel3.add(chSynchronized);

            chPrivate=new Checkbox("Private",group1, true);
            panel3.add(chPrivate);
            chPackage=new Checkbox("Package",group1, false);
            panel3.add(chPackage);
            chProtected=new Checkbox("Protected",group1, false);
            panel3.add(chProtected);
            chPublic=new Checkbox("Public",group1, false);
            panel3.add(chPublic);
            switch( m.access() )
            {
            case 0: chPublic.setState(true);break;
            case 1: chPackage.setState(true);break;
            case 2: chPrivate.setState(true);break;
            case 3: chProtected.setState(true);break;
            }
            panel2.add(panel3);


            panel4=new Panel();
            panel4.setLayout(new HorizLayout(HorizLayout.RESIZE,HorizLayout.TOP));

            panel = new Panel();
            panel.setLayout(new DLayout());
            Label l = new Label("Method return type:");
            panel.add(l);
            editType = new TextField(mm.type,20);
            panel.add(editType);
            panel4.add(panel);

            panel = new Panel();
            panel.setLayout(new DLayout());
            l = new Label("Method name:");
            panel.add(l);
            editName = new TextField(mm.name,20);
            panel.add(editName);
            panel4.add(panel);

            panel = new Panel();
            panel.setLayout(new DLayout());
            l = new Label("Parameters:");
            panel.add(l);
            editParameters = new TextArea(3,20);
            panel.add(editParameters);
            String[] param = mm.getParameters();
            int i,k = param.length;
            for(i=0;i<k;i++)
                editParameters.appendText(param[i] + "\n");
            panel4.add(panel);

            panel = new Panel();
            panel.setLayout(new DLayout());
            l = new Label("Throws:");
            panel.add(l);
            editThrows = new TextArea(3,20);
            panel.add(editThrows);
            param = mm.getThrows();
            k = param.length;
            for(i=0;i<k;i++)
                editThrows.appendText(param[i] + "\n");
            panel4.add(panel);
            panel2.add(panel4);
            add(panel2);
        }else // variable
        {
            BrVariable v = (BrVariable)member;

            setTitle("Variable " + member.object.getNameWithPackage() +
                "." + member.name);

            chStatic=new Checkbox("Static");
            if( !v.one )
                chStatic.disable();
            chStatic.setState(m.staticM());
            panel3.add(chStatic);
            chFinal=new Checkbox("Final");
            if( !v.one )
                chFinal.disable();
            chFinal.setState(m.finalM());
            panel3.add(chFinal);
            chThreadsafe=new Checkbox("Threadsafe");
            if( !v.one )
                chThreadsafe.disable();
            chThreadsafe.setState(m.threadsafeM());
            panel3.add(chThreadsafe);
            chTransient=new Checkbox("Transient");
            if( !v.one )
                chTransient.disable();
            chTransient.setState(m.transientM());
            panel3.add(chTransient);

            chPrivate=new Checkbox("Private",group1, true);
            if( !v.one )
                chPrivate.disable();
            panel3.add(chPrivate);
            chPackage=new Checkbox("Package",group1, false);
            if( !v.one )
                chPackage.disable();
            panel3.add(chPackage);
            chProtected=new Checkbox("Protected",group1, false);
            if( !v.one )
                chProtected.disable();
            panel3.add(chProtected);
            chPublic=new Checkbox("Public",group1, false);
            if( !v.one )
                chPublic.disable();
            panel3.add(chPublic);
            switch( m.access() )
            {
            case 0: chPublic.setState(true);break;
            case 1: chPackage.setState(true);break;
            case 2: chPrivate.setState(true);break;
            case 3: chProtected.setState(true);break;
            }
            panel2.add(panel3);


            panel4=new Panel();
            panel4.setLayout(new HorizLayout(HorizLayout.RESIZE,HorizLayout.TOP));

            panel = new Panel();
            panel.setLayout(new DLayout());
            Label l = new Label("Variable type:");
            panel.add(l);
            editType = new TextField(member.type,20);
            if( !v.one )
                editType.setEditable(false);
            panel.add(editType);
            panel4.add(panel);

            panel = new Panel();
            panel.setLayout(new DLayout());
            l = new Label("Variable name:");
            panel.add(l);
            editName = new TextField(member.name,20);
            panel.add(editName);
            panel4.add(panel);

            panel = new Panel();
            panel.setLayout(new DLayout());
            l = new Label("Initial value:");
            panel.add(l);
            editInitValue = new TextField(v.init,20);
            panel.add(editInitValue);
            panel4.add(panel);

            panel2.add(panel4);
            add(panel2);
        }

        panel5 = new Panel();
        panel5.setLayout(new GridLayout(2,5));

        buttonTextEditor = new Button("Text Editor");
        panel5.add(buttonTextEditor);
        buttonHint = new Button("Hint");
        panel5.add(buttonHint);

        buttonNew = new Button("New");
        panel5.add(buttonNew);
        buttonDelete = new Button("Delete");
        if( !methodView && !((BrVariable)member).one )
            buttonDelete.disable();
        panel5.add(buttonDelete);
        panel4.add(panel5);

        panel1=new Panel();
        panel1.setLayout(new GridLayout(1,2));

        panel = new Panel();
        panel.setLayout(new FlowLayout());
        buttonCopy=new Button("Copy");
        //panel.add(buttonCopy);
        buttonPaste=new Button("Paste");
        if( (BrowserSettings.Clipboard == null) ||
            !(BrowserSettings.Clipboard[0] instanceof
                xelfi.browser.document.BrProject) )
            buttonPaste.disable();
        //panel.add(buttonPaste);
        buttonCut=new Button("Cut");
        //panel.add(buttonCut);
        panel1.add(panel);

        panel = new Panel();
        panel.setLayout(new FlowLayout());
        buttonOK=new Button("OK");
        panel.add(buttonOK);
        buttonCancel=new Button("Cancel");
        panel.add(buttonCancel);
        buttonHelp=new Button("Help");
        //panel.add(buttonHelp);
        panel1.add(panel);
        add(panel1);



        resize(insets().left + insets().right + preferredSize().width, insets().top + insets().bottom + preferredSize().height);

       setResizable(false);
        Dimension d = getToolkit().getScreenSize();
        move( (d.width - size().width) / 2 , (d.height - size().height) / 2 );
        show();
        resize(preferredSize());

    }

    /*public synchronized void show() {
       Rectangle bounds = getParent().bounds();
       Rectangle abounds = bounds();

       move(bounds.x + (bounds.width - abounds.width)/ 2,
            bounds.y + (bounds.height - abounds.height)/2);

       super.show();
    }*/

    public synchronized void wakeUp() {
       notify();
    }

    public boolean handleEvent(Event event) {

       if (event.id == Event.WINDOW_DESTROY) {
           dispose();
           return true;
       }else
        if( event.id == Event.ACTION_EVENT )
        {
            if( event.target == buttonTextEditor )
            {
                dispose();
                textEditor(member);
                return true;
            }else
            if( event.target == buttonHint )
            {
                dispose();
                new HintWindow(BrowserSettings.mainWindow,member);
                /*System.out.println("otevrit");
                Source s = null;
                try{
                    s = new Source(member.getXFile());
                }catch(IOException e)
                {
                    new modalDialog(BrowserSettings.mainWindow,
                        null,0,"IO Exception ",
                        null,null,
                        modalDialog.OK);
                    return true;
                }
                if( !member.object.isLoaded )
                {
                    System.out.println("neni otevreno !!!");
                    return true;
                }
                System.out.println("otevrit 1");
                if( methodView )
                {
                    if( member.getBodyEnd()==null)
                        System.out.println("null");
                    TopLevel.showEditor(s,member.getBodyEnd(),true);
                }else
                {
                    if( member.getEnd()==null)
                        System.out.println("null");
                    TopLevel.showEditor(s,member.getEnd(),true);
                }
                System.out.println("otevreno");*/
                return true;
            }else
            if( event.target == buttonNew )
            {
                dispose();
                try
                {
                    if( methodView )
                    {
                        Modifiers modif = new Modifiers();
                        if( chPublic.getState() )       modif.setPublic();
                        if( chPrivate.getState() )      modif.setPrivate();
                        if( chProtected.getState() )    modif.setProtected();
                        if( chAbstract.getState() )     modif.setAbstract();
                        if( chFinal.getState() )        modif.setFinal();
                        if( chNative.getState() )       modif.setNative();
                        if( chStatic.getState() )       modif.setStatic();
                        if( chSynchronized.getState() ) modif.setSynchronized();
                        //System.out.println("1");
                        member.addMember(new BrMethod(
                            (MyPosition)null,
                            (MyPosition)null,
                            (MyPosition)null,
                            (MyPosition)null,
                            member.object,
                            editName.getText(),
                            member.getXFile(),
                            modif,
                            editType.getText(),
                            editParameters.getText(),
                            editThrows.getText()));
                    }else
                    {
                        Modifiers modif = new Modifiers();
                        if( chPublic.getState() )       modif.setPublic();
                        if( chPrivate.getState() )      modif.setPrivate();
                        if( chProtected.getState() )    modif.setProtected();
                        if( chStatic.getState() )       modif.setStatic();
                        if( chFinal.getState() )        modif.setFinal();
                        if( chThreadsafe.getState() )   modif.setThreadsafe();
                        if( chTransient.getState() )    modif.setTransient();

                        member.addMember(new BrVariable(
                            (MyPosition)null,
                            (MyPosition)null,
                            (MyPosition)null,
                            (MyPosition)null,
                            ((BrVariable)member).one,
                            member.object,
                            editName.getText(),
                            member.getXFile(),
                            modif,
                            editType.getText(),
                            editInitValue.getText()));
                    }
                    BrowserSettings.repaint(4);
                }catch(IOException e)
                {
                     new modalDialog(BrowserSettings.mainWindow,
                        null,0,"IO Exception ",
                        null,null,
                        modalDialog.OK);
                    return true;
                }catch(NotAllowedException e)
                {
                    new modalDialog(BrowserSettings.mainWindow,
                        null,0,"It's impossible to add text here !!! ",
                        null,null,
                        modalDialog.OK);
                    return true;
                }catch(EndOfTextException e)
                {
                    System.out.println("Error 868 MemberView");
                }
                return true;
            }else
            if( event.target == buttonDelete )
            {
                dispose();
                d = new modalDialog(BrowserSettings.mainWindow,this,1,
                    "Do you really want to delete ",
                    "this member ?",null,
                    modalDialog.YES_NO);
                return true;
            }else
            if( event.target == buttonCopy )
            {
                dispose();
                return true;
            }else
            if( event.target == buttonPaste )
            {
                dispose();
                return true;
            }else
            if( event.target == buttonCut )
            {
                dispose();
                return true;
            }else
            if( event.target == buttonOK )
            {
                dispose();
                try
                {
                    if( methodView )
                    {
                        Modifiers modif = new Modifiers();
                        if( chPublic.getState() )       modif.setPublic();
                        if( chPrivate.getState() )      modif.setPrivate();
                        if( chProtected.getState() )    modif.setProtected();
                        if( chAbstract.getState() )     modif.setAbstract();
                        if( chFinal.getState() )        modif.setFinal();
                        if( chNative.getState() )       modif.setNative();
                        if( chStatic.getState() )       modif.setStatic();
                        if( chSynchronized.getState() ) modif.setSynchronized();
                        //System.out.println("1");
                        member.changeMember(new BrMethod(
                            (MyPosition)null,
                            (MyPosition)null,
                            (MyPosition)null,
                            (MyPosition)null,
                            member.object,
                            editName.getText(),
                            member.getXFile(),
                            modif,
                            editType.getText(),
                            editParameters.getText(),
                            editThrows.getText()));
                    }else
                    {
                        Modifiers modif = new Modifiers();
                        if( chPublic.getState() )       modif.setPublic();
                        if( chPrivate.getState() )      modif.setPrivate();
                        if( chProtected.getState() )    modif.setProtected();
                        if( chStatic.getState() )       modif.setStatic();
                        if( chFinal.getState() )        modif.setFinal();
                        if( chThreadsafe.getState() )   modif.setThreadsafe();
                        if( chTransient.getState() )    modif.setTransient();

                        member.changeMember(new BrVariable(
                            (MyPosition)null,
                            (MyPosition)null,
                            (MyPosition)null,
                            (MyPosition)null,
                            ((BrVariable)member).one,
                            member.object,
                            editName.getText(),
                            member.getXFile(),
                            modif,
                            editType.getText(),
                            editInitValue.getText()));
                    }
                    BrowserSettings.repaint(4);
                }catch(NotAllowedException e)
                {
                    new modalDialog(BrowserSettings.mainWindow,
                        null,0,"It's impossible to add text here !!! ",
                        null,null,
                        modalDialog.OK);
                    return true;
                }catch(IOException e)
                {
                     new modalDialog(BrowserSettings.mainWindow,
                        null,0,"IO Exception ",
                        null,null,
                        modalDialog.OK);
                    return true;
                }catch(EndOfTextException e)
                {
                    System.out.println("Error 638 MemberView");
                }
                return true;
            }else
            if( event.target == buttonCancel )
            {
                dispose();
                return true;
            }else
            if( event.target == buttonHelp )
            {
                dispose();
                return true;
            }
        }
       return super.handleEvent(event);
    }

    Panel panel2;
    Panel panel1;
    Panel panel3;
    Panel panel8;
    Panel panel4;
    Panel panel5;
    Panel panel6;
    Panel panel7;
    CheckboxGroup group1;
    Button buttonTextEditor,
        buttonHint ,
        buttonNew ,
        buttonDelete ,

        buttonCopy ,
        buttonPaste ,
        buttonCut;

    Button buttonOK;
    Button buttonCancel;
    Button buttonHelp;
    Checkbox chFinal;
    Checkbox chStatic;
    Checkbox chThreadsafe;
    Checkbox chTransient;
    Checkbox chAbstract;
    Checkbox chNative;
    Checkbox chSynchronized;
    Checkbox chPublic;
    Checkbox chPrivate;
    Checkbox chProtected;
    Checkbox chPackage;
    Checkbox chPProtected;
    TextField editName;
    TextField editType;
    TextField editInitValue;
    TextArea editParameters;
    TextArea editThrows;

    public void onOk(int index)
    {
        switch( index )
        {
        case 1:
            try{
                member.deleteMember();
            }catch(IOException e)
            {
                new modalDialog(BrowserSettings.mainWindow,
                    null,0,"IO Exception ",
                    null,null,
                    modalDialog.OK);
                return;
            }catch(InvalidPositionException e)
            {
                System.out.println("Member view " + e);
                return;
            }catch(EndOfTextException e)
            {
                System.out.println("Member view " + e);
                return;
            }catch(NotAllowedException e)
            {
                new modalDialog(BrowserSettings.mainWindow,
                    null,0,"It's impossible to delete text here !!! ",
                    null,null,
                    modalDialog.OK);
            }
            BrowserSettings.repaint(4);
            break;
        case 2:
            break;
        case 3:
            break;
        case 4:
            break;
        }
    }
    public void onNo(int index)
    {
        switch( index )
        {
        case 1:
            break;
        case 2:
            break;
        case 3:
            break;
        case 4:
            break;
        case 5:
            break;
        }
    }
    public void onCancel(int index)
    {
        switch( index )
        {
        case 1:
            break;
        case 2:
            break;
        case 3:
            break;
        }
    }

    static void textEditor(BrMember member)
    {
        //System.out.println("otevrit");
        Source s = null;
        try{
            s = new Source(member.getXFile());
        }catch(IOException e)
        {
            new modalDialog(BrowserSettings.mainWindow,
                null,0,"IO Exception ",
                null,null,
                modalDialog.OK);
            return;
        }
        if( !member.object.isLoaded )
        {
            System.out.println("Error 378 ");
        }
        //System.out.println("otevrit");
        if( member.getBegin() == null)
          System.out.println("Error 379");
        s.showAll ();
        TopLevel.showEditor(s,member.getBegin(),true);
        //System.out.println("otevreno");
    }

}



