/**
* Xelfi
*/

package xelfi.design.components.property;

import java.io.*;
import xelfi.util.Debug;

/**
 *
 * @version 	1.40, 08 Feb 1997 (from version 1.30 persistence is added)
 * @author 	Ian Formanek
 */
public class XBooleanPropertyType {
	public static String viewString(Object property) {
		return ((Boolean)property).toString();
	}

	public static void saveToStream(Object property, DataOutput stream) throws 
		IOException {
		stream.writeBoolean(((Boolean)property).booleanValue());
		Debug.debug(Debug.PROPIO_SAVE, "XBooleanProperty saved: "+(Boolean)property);
	}

	public static void saveToStream(boolean property, DataOutput stream) throws 
		IOException {
		stream.writeBoolean(property);
		Debug.debug(Debug.PROPIO_SAVE, "XBooleanProperty saved: "+property);
	}

	public static Boolean loadFromStream(DataInput stream) throws 
		IOException {
		boolean property = stream.readBoolean();
		Debug.debug(Debug.PROPIO_LOAD, "XBooleanProperty loaded: "+property);
		return new Boolean(property);
	}

	public static boolean loadBFromStream(DataInput stream) throws 
		IOException {
		boolean property = stream.readBoolean();
		Debug.debug(Debug.PROPIO_LOAD, "XBooleanProperty loaded: "+property);
		return property;
	}

}