/**
* Xelfi
*/

package xelfi.design.components.property;

/**
  *
  * @version 	1.00, 12 Jan 1997
  * @author 	Petr Hamernik
  *
  */

public class XFImageName {
	public final static int IN_URL = 0;
	public final static int IN_PATH = 1;
	public final static int IN_PACKAGE = 2;
	
	private int type;
	private String text1;
	private String text2;
	
	public XFImageName(int aType) {
		type = aType;
		text1 = "";
		text2 = "";
	}
	
	public XFImageName(XFImageName aIname) {
		type = aIname.getType();
		text1 = aIname.getText1();
		text2 = aIname.getText2();
	}

	public XFImageName(int aType, String aText1) {
		type = aType;
		text1 = aText1;
		text2 = "";
	}
	
	public XFImageName(int aType, String aText1, String aText2) {
		type = aType;
		text1 = aText1;
		text2 = aText2;
	}

	public XFImageName(String aText1, String aText2) {
		type = IN_PACKAGE;
		text1 = aText1;
		text2 = aText2;
	}

	public int getType() {
		return type;
	}

	public String getText1() {
		return text1;
	}
	
	public String getText2() {
		return text2;
	}

	public void setText1(String aText) {
		text1 = aText;
	}
	
	public void getText2(String aText) {
		text2 = aText;
	}

	public void setURL(String aText) {
		type = IN_URL;
		text1 = aText;
		text2 = "";
	}

	public void setPath(String aText) {
		type = IN_PATH;
		text1 = aText;
		text2 = "";
	}

	public void setPackage(String aText1, String aText2) {
		type = IN_PATH;
		text1 = aText1;
		text2 = aText2;
	}

	public boolean isURL() {
		return (type == IN_URL);
	}

	public boolean isPath() {
		return (type == IN_PATH);
	}

	public boolean isPackage() {
		return (type == IN_PACKAGE);
	}
}