/**
* Xelfi
*/

package xelfi.design.components.xawt;

/**
  *
  * @version 	2.12, 03 Apr 1997
  * @author 	Petr Hamernik
  *
  */

import java.awt.*;
import java.io.*;
import xelfi.awt.Gauge;
import xelfi.design.components.*;
import xelfi.design.components.property.*;
import xelfi.design.forms.XelfiDesignForm;
import xelfi.design.util.XFDesignConstants;
import xelfi.design.util.XFDesignOptions;
import xelfi.design.util.XFDesignUtils;

public class XGauge extends XAWTPanel {
	private Gauge gauge;

	private static int propertyCount = 15;
	private Object propDef[];
	private boolean propDefSet = false;
	private static int eventCount = 2;
	private String events[] = new String[eventCount];
	protected static Image icon = null;
	
	public XGauge() { 
		super(XAWTPanel.WITHOUT_DRAGBORDER);
		setComponent(gauge = new Gauge());
		propDef = new Object[propertyCount];
		for (int i=0; i<propertyCount; i++)
			propDef[i] = null;
		if (icon == null)
			icon = loadIcon("gauge.gif");
	}

	protected void regenForm(int what) {
		if (parentForm != null)
			parentForm.regenerateCode(this, what);
	}

	public String[] neededImports() {
		String[] ret = new String[1];
		ret[0] = "xelfi.awt.Gauge";
		return ret;
	}

	public Image getIcon() {
		return icon; 
	}

	public boolean handleEvent(Event evt) {
		evt.target = this;
		return super.handleEvent(evt);
	}

	private boolean propertyDefault(int i) throws XFPropertyIndexOutOfBoundsException {
		if (propDefSet)
			propertiesSetDefault();
		if (propDef[i] == null)
			return false;
		switch (i) {
			case 0: return ((Color) propDef[i]).equals(gauge.getBackground());
			case 1: return ((Color) propDef[i]).equals(gauge.getForeground());
			case 2: return (((Boolean) propDef[i]).booleanValue() == gauge.isEnabled());
			case 3: return (((Boolean) propDef[i]).booleanValue() == bVisible);
			case 4: return ((Font) propDef[i]).equals(gauge.getFont());
			case 5: return (((Boolean) propDef[i]).booleanValue() == autoSize);
			case 6: return (((Boolean) propDef[i]).booleanValue() == parentColor);
			case 7: return (((Boolean) propDef[i]).booleanValue() == parentFont);
			case 8: return (gauge.defaultFillColor.equals(gauge.getFillColor()));
			case 9: return (gauge.defaultKind == gauge.getKind());
			case 10: return (((Boolean) propDef[i]).booleanValue() == gauge.getShowText());
			case 11: return (gauge.defaultBorderColor.equals(gauge.getBorderColor()));
			case 12: return (gauge.defaultBorderWidth == gauge.getBorderWidth());
			case 13: return (gauge.defaultBorderStyle == gauge.getBorderStyle());
			case 14: return (gauge.getValue() == 0);
			default: throw new XFPropertyIndexOutOfBoundsException();
		}
	}

	private void propertiesSetDefault() {
		if (propDefSet)
			return;
		propDefSet = true;
		if (getBackground() != null)
				propDef[0] = new Color(gauge.getBackground().getRGB());
		if (getForeground() != null)
				propDef[1] = new Color(gauge.getForeground().getRGB());
		propDef[2] = new Boolean(gauge.isEnabled());
		propDef[3] = new Boolean(bVisible);
		if (gauge.getFont() != null) {
			Font f = gauge.getFont();
			propDef[4] = new Font(f.getName(), f.getStyle(), f.getSize());
		}
		propDef[5] = new Boolean(autoSize);
		propDef[6] = new Boolean(parentColor);
		propDef[7] = new Boolean(parentFont);
		propDef[8] = gauge.defaultFillColor;
		propDef[9] = new Integer(gauge.defaultKind);
		propDef[10] = new Boolean(gauge.defaultShowText);
		propDef[11] = gauge.defaultBorderColor;
		propDef[12] = new Integer(gauge.defaultBorderWidth);
		propDef[13] = new Integer(gauge.defaultBorderStyle);
		propDef[14] = new Integer(0);
	}

	public int getPropertyCount() { return propertyCount; }
	
	public Object getProperty(int index) throws XFPropertyIndexOutOfBoundsException { 
		switch (index) {
			case 0: return gauge.getBackground();
			case 1: return gauge.getForeground();
			case 2: return (gauge.isEnabled()) ? Boolean.TRUE : Boolean.FALSE;
			case 3: return (bVisible) ? Boolean.TRUE : Boolean.FALSE;
			case 4: return gauge.getFont();
			case 5: return (autoSize) ? Boolean.TRUE : Boolean.FALSE;
			case 6: return (parentColor) ? Boolean.TRUE : Boolean.FALSE;
			case 7: return (parentFont) ? Boolean.TRUE : Boolean.FALSE;
			case 8: return gauge.getFillColor();
			case 9: return new Integer(gauge.getKind());
			case 10: return (gauge.getShowText()) ? Boolean.TRUE : Boolean.FALSE;
			case 11: return gauge.getBorderColor();
			case 12: return new Integer(gauge.getBorderWidth());
			case 13: return new Integer(gauge.getBorderStyle());
			case 14: return new Integer(gauge.getValue());
			default: throw new XFPropertyIndexOutOfBoundsException();
		}
	}
			
	public String[] getPropertyNames() { 
		String list[] = new String[propertyCount];
		list[0] = "Background Color";
		list[1] = "Foreground Color";
		list[2] = "Enabled";
		list[3] = "Visible";
		list[4] = "Font";
		list[5] = "Auto Size";
		list[6] = "Parent Color";
		list[7] = "Parent Font";
		list[8] = "Fill Color";
		list[9] = "Kind";
		list[10] = "Show Text";
		list[11] = "Border Color";
		list[12] = "Border Width";
		list[13] = "Border Style";
		list[14] = "Value";
		return list;
	}
		
	public String getPropertyString(int index) throws 
		XFPropertyIndexOutOfBoundsException { 
		switch (index) {
			case 0: 
			case 1: return XColorPropertyType.viewString(getProperty(index));
			case 2:
			case 3: return XBooleanPropertyType.viewString(getProperty(index));
			case 4: return XFontPropertyType.viewString(getProperty(index));
			case 5: 
			case 6: 
			case 7: return XBooleanPropertyType.viewString(getProperty(index));
			case 8: return XColorPropertyType.viewString(getProperty(index));
			case 9: return XIntegerPropertyType.viewString(getProperty(index));
			case 10: return XBooleanPropertyType.viewString(getProperty(index));
			case 11: return XColorPropertyType.viewString(getProperty(index));
			case 12:
			case 13:
			case 14: return XIntegerPropertyType.viewString(getProperty(index));
			default: throw new XFPropertyIndexOutOfBoundsException();
		}
	}

	public int getPropertyViewerType(int index) throws 
		XFPropertyIndexOutOfBoundsException {
		switch (index) {
			case 0: 
			case 1: return XFDesignConstants.PVT_SPECIAL;
			case 2:
			case 3: return XFDesignConstants.PVT_CHECK;
			case 4: return XFDesignConstants.PVT_SPECIAL;
			case 5: 
			case 6: 
			case 7: return XFDesignConstants.PVT_CHECK;
			case 8: return XFDesignConstants.PVT_SPECIAL;
			case 9: return XFDesignConstants.PVT_CHOICE_STRICT;
			case 10: return XFDesignConstants.PVT_CHECK;
			case 11: return XFDesignConstants.PVT_SPECIAL;
			case 12: return XFDesignConstants.PVT_INPUT_INT;
			case 13: return XFDesignConstants.PVT_CHOICE_STRICT;
			case 14: return XFDesignConstants.PVT_INPUT_INT;
			default: throw new XFPropertyIndexOutOfBoundsException();
		}
	}

	public String[] getPropertyValueNames(int index) throws 
		XFPropertyIndexOutOfBoundsException {
		switch (index) {
			case 9: String[] ret = new String[5];
					ret[0] = "HORIZONTAL";
					ret[1] = "VERTICAL";
					ret[2] = "NEEDLE";
					ret[3] = "PIE";
					ret[4] = "TEXT";
					return ret;
			case 13:String[] ret1 = new String[4];
					ret1[0] = "NONE";
					ret1[1] = "NORMAL";
					ret1[2] = "3D RAISED";
					ret1[3] = "3D LOWERED";
					return ret1;
			default: throw new XFPropertyIndexOutOfBoundsException();
		}
	}

	public Object[] getPropertyValueValues(int index) throws 
		XFPropertyIndexOutOfBoundsException {
		switch (index) {
			case 9: Integer[] ret = new Integer[5];
					ret[0] = new Integer(Gauge.GAUGE_HORIZONTAL);
					ret[1] = new Integer(Gauge.GAUGE_VERTICAL);
					ret[2] = new Integer(Gauge.GAUGE_NEEDLE);
					ret[3] = new Integer(Gauge.GAUGE_PIE);
					ret[4] = new Integer(Gauge.GAUGE_TEXT);
					return ret;
			case 13: Integer[] ret1 = new Integer[4];
					ret1[0] = new Integer(Gauge.BS_NONE);
					ret1[1] = new Integer(Gauge.BS_NORMAL);
					ret1[2] = new Integer(Gauge.BS_3D_RAISED);
					ret1[3] = new Integer(Gauge.BS_3D_LOWERED);
					return ret1;
			default: throw new XFPropertyIndexOutOfBoundsException();
		}
	}

	public int setProperty(int index, Object value) throws 	
		XFPropertyIndexOutOfBoundsException,
		XFPropertyBadValueTypeException 
	{ 
		int ret = XFDesignConstants.RSP_OK;
		int regen = XFDesignConstants.GEN_SETPROPS;
		if (!propDefSet)
			propertiesSetDefault();
		switch (index) { 
			case 0: if (!(value instanceof Color)) throw new XFPropertyBadValueTypeException();
					gauge.setBackground((Color)value);
					ret = ret | XFDesignConstants.RSP_REPAINT_COMP;
					if (parentColor) {
						parentColor = false;
						ret = ret | XFDesignConstants.RSP_OTHER_PROP;
					}
					gauge.repaint();
					break;
			case 1:	if (!(value instanceof Color)) throw new XFPropertyBadValueTypeException();
					gauge.setForeground((Color)value);
					ret = ret | XFDesignConstants.RSP_REPAINT_COMP;
					if (parentColor) {
						parentColor = false;
						ret = ret | XFDesignConstants.RSP_OTHER_PROP;
					}
					gauge.repaint();
					break;
			case 2:	if (!(value instanceof Boolean)) throw new XFPropertyBadValueTypeException();
					gauge.enable(((Boolean)value).booleanValue());
					break;
			case 3: if (!(value instanceof Boolean)) throw new XFPropertyBadValueTypeException();
					bVisible = ((Boolean)value).booleanValue();
					break;
			case 4: if (!(value instanceof Font)) throw new XFPropertyBadValueTypeException();
					gauge.setFont((Font)value); 
					ret = ret | XFDesignConstants.RSP_REPAINT_COMP | XFDesignConstants.RSP_OTHER_PROP;
					if (parentFont) {
						parentFont = false;
						if (autoSize) {
							setDesignSize(0,0);
							regen = regen | XFDesignConstants.GEN_RESHAPE;
							gauge.repaint();
						}
					}
					break;
			case 5:	if (!(value instanceof Boolean)) throw new XFPropertyBadValueTypeException();
					setAutoSize(((Boolean)value).booleanValue());
					if (autoSize) {
						setDesignSize(0,0);
						ret = ret | XFDesignConstants.RSP_OTHER_PROP;
						gauge.repaint();
					}
					regen = regen | XFDesignConstants.GEN_RESHAPE;
					ret = ret | XFDesignConstants.RSP_REPAINT_COMP;
					break;
			case 6:	if (!(value instanceof Boolean)) throw new XFPropertyBadValueTypeException();
					setParentColor(((Boolean)value).booleanValue());
					if (parentColor)
						ret = ret | XFDesignConstants.RSP_REPAINT_COMP;
					break;
			case 7: if (!(value instanceof Boolean)) throw new XFPropertyBadValueTypeException();
					setParentFont(((Boolean)value).booleanValue());
					if (parentFont)
						ret = ret | XFDesignConstants.RSP_REPAINT_COMP;
					if (autoSize)
					 	ret = ret | XFDesignConstants.RSP_OTHER_PROP;
					break;
			case 8:if (!(value instanceof Color)) throw new XFPropertyBadValueTypeException();
					gauge.setFillColor((Color)value);
					ret = ret | XFDesignConstants.RSP_REPAINT_COMP;
					break;
			case 9:if (!(value instanceof Integer)) throw new XFPropertyBadValueTypeException();
					gauge.setKind(((Integer)value).intValue());
					ret = ret | XFDesignConstants.RSP_REPAINT_COMP;
					if (autoSize) {
						setDesignSize(0,0);
						ret = ret | XFDesignConstants.RSP_OTHER_PROP;
					}
					repaintComponent();
					break;
			case 10:if (!(value instanceof Boolean)) throw new XFPropertyBadValueTypeException();
					gauge.setShowText(((Boolean)value).booleanValue());
					break;
			case 11:if (!(value instanceof Color)) throw new XFPropertyBadValueTypeException();
					gauge.setBorderColor((Color)value);
					ret = ret | XFDesignConstants.RSP_REPAINT_COMP;
					break;
			case 12:if (!(value instanceof Integer)) throw new XFPropertyBadValueTypeException();
					gauge.setBorderWidth(((Integer)value).intValue());
					if (autoSize) {
						setDesignSize(0,0);
						ret = ret | XFDesignConstants.RSP_OTHER_PROP;
					}
					repaintComponent();
					break;
			case 13:if (!(value instanceof Integer)) throw new XFPropertyBadValueTypeException();
					gauge.setBorderStyle(((Integer)value).intValue());
					if (autoSize) {
						setDesignSize(0,0);
						ret = ret | XFDesignConstants.RSP_OTHER_PROP;
					}
					repaintComponent();
					break;
			case 14:if (!(value instanceof Integer)) throw new XFPropertyBadValueTypeException();
					try {
						gauge.setValue(((Integer)value).intValue());
					} catch (IllegalArgumentException e) {
						System.out.println("Illegal Argument Exception.");
					}
					break;
			default: throw new XFPropertyIndexOutOfBoundsException();
		}
		regenForm(regen);
		
		return ret;
	}
			
	public void specialPropertyInput(Frame parent, int index) throws 	
		XFPropertyIndexOutOfBoundsException, 
		XFPropertyNoSpecialInputException { 
		if ((index < 0) || (index >= propertyCount)) throw new XFPropertyIndexOutOfBoundsException();
		switch (index) { 
			case 0:
			case 1: XColorPropertyType.invokeSpecialInput(parent, this, index);
					break;
			case 4: XFontPropertyType.invokeSpecialInput(parent, this, index);
					break;
			case 8:
			case 11: XColorPropertyType.invokeSpecialInput(parent, this, index);
					break;
			default: throw new XFPropertyNoSpecialInputException();
		}
	}

	public int getEventCount() {
		return eventCount;
	}

	public String[] getEventNames() {
		String list[] = new String[eventCount];
		list[0] = "OnGotFocus";
		list[1] = "OnLostFocus";
		return list;
	}

	public String getEvent(int index) throws 
		XFPropertyIndexOutOfBoundsException {
		if ((index>=0) && (index<eventCount)) {
			if (events[index] == null)
				return null;
			else
				return new String(events[index]); 
		}
		else throw new XFPropertyIndexOutOfBoundsException();
	}		
		
	public void setEvent(int index, String value) throws 
		XFPropertyIndexOutOfBoundsException {
		if ((index>=0) && (index<eventCount))
			events[index] = value;
		else throw new XFPropertyIndexOutOfBoundsException();
	}		

	public String getClassName() {
		return "Gauge";
	}
	
	public String generateCode(int what) {
		String gen = "";
		switch (what) {
			case XFDesignConstants.GEN_VARIABLE: 
				gen = getClassName()+" "+ name + ";\n";
				break;
			case XFDesignConstants.GEN_INIT: 
				gen = name + " = new " + getClassName() + "();\n";
				break;
			case XFDesignConstants.GEN_SETPROPS:
				if (!propDefSet)
					propertiesSetDefault();
				for (int i = 0; i < propertyCount; i++) {
					if (!propertyDefault(i)) {
						switch(i) {
							case 0: if (!parentColor)
										gen = gen + name + ".setBackground(" +
											XFDesignUtils.genColor(gauge.getBackground()) + ");\n";
									break;
							case 1: if (!parentColor)
										gen = gen + name + ".setForeground(" +
											XFDesignUtils.genColor(gauge.getForeground()) + ");\n";
									break;
							case 2: gen = gen + name + (gauge.isEnabled() ? ".enable();\n" : ".disable();\n");
									break;
							case 3: gen = gen + name + ((bVisible) ? ".show();\n" : ".hide();\n");
									break;
							case 4: if (!parentFont) {
										gen = gen + name + ".setFont(" + 
											XFDesignUtils.genFont(gauge.getFont())+");\n";
									}
									break;
							case 8: gen = gen + name + ".setFillColor(" +
										XFDesignUtils.genColor(gauge.getFillColor()) + ");\n";
									break;
							case 9: gen = gen + name + ".setKind(Gauge.GAUGE_";
									switch (gauge.getKind()) {
										case Gauge.GAUGE_HORIZONTAL: gen = gen + "HORIZONTAL"; break;
										case Gauge.GAUGE_VERTICAL: gen = gen + "VERTICAL"; break;
										case Gauge.GAUGE_NEEDLE: gen = gen + "NEEDLE"; break;
										case Gauge.GAUGE_PIE: gen = gen + "PIE"; break;
										case Gauge.GAUGE_TEXT: gen = gen + "TEXT"; break;
									}
									gen = gen + ");\n";
									break;
							case 10: gen = gen + name + ".setShowText(" + ((gauge.getShowText()) ? "true" : "false") + ");\n";
									break;
							case 11: gen = gen + name + ".setBorderColor(" +
										XFDesignUtils.genColor(gauge.getBorderColor()) + ");\n";
									break;
							case 12: gen = gen + name + ".setBorderWidth(" + gauge.getBorderWidth() + ");\n";
									break;
							case 13: gen = gen + name + ".setBorderStyle(Gauge.BS_";
									switch (gauge.getBorderStyle()) {
										case Gauge.BS_NONE: gen = gen + "NONE"; break;
										case Gauge.BS_NORMAL: gen = gen + "NORMAL"; break;
										case Gauge.BS_3D_RAISED: gen = gen + "3D_RAISED"; break;
										case Gauge.BS_3D_LOWERED: gen = gen + "3D_LOWERED"; break;
									}
									gen = gen + ");\n";
									break;
							case 14: gen = gen + name + ".setValue(" + gauge.getValue() + ");\n";
									break;
						}
					}
				}
				break;			
			case XFDesignConstants.GEN_RESHAPE:
				if (((XelfiVisualContainer) getParent()).getDesignLayout().allowsDragging()) {
					if (!autoSize) 
						if (getParent() instanceof XelfiDesignForm)
							gen = name + ".reshape(insets.left+"+position.x+", insets.top+"+position.y+","+size.width+","+size.height+");\n";
						else 
							gen = name + ".reshape("+position.x+","+position.y+","+size.width+","+size.height+");\n";
					else {
						gen = name + ".resize(" + name + ".preferredSize());\n";
						if (getParent() instanceof XelfiDesignForm)
							gen = gen + name + ".move(insets.left+"+position.x+", insets.top+"+position.y+");\n";
						else
							gen = gen + name + ".move("+position.x+","+position.y+");\n";
					}
				}
				break;
		}
		return gen;
	}

	public String generateEventCondition(int index) throws XFPropertyIndexOutOfBoundsException {
		String evt = XFDesignOptions.eventVarName;
		switch (index) { 
			case 0: return evt +".id == Event.GOT_FOCUS && "+evt+".target == "+getName();
			case 1: return evt +".id == Event.LOST_FOCUS && "+evt+".target == "+getName();
			default: throw new XFPropertyIndexOutOfBoundsException();
		}
	}

	public void loadFromStream(DataInput stream) throws IOException {

		super.loadFromStream(stream);

		if (!propDefSet)
			propertiesSetDefault();

		for (int i = 0; i < propertyCount; i++) {
			if (stream.readBoolean())
				propDef[i] = null;
			else switch (i) {
				case 0: gauge.setBackground(XColorPropertyType.loadFromStream(stream)); break;
				case 1: gauge.setForeground(XColorPropertyType.loadFromStream(stream)); break;
				case 2: gauge.enable(XBooleanPropertyType.loadBFromStream(stream)); break;
				case 3: bVisible = XBooleanPropertyType.loadBFromStream(stream); break;
				case 4: gauge.setFont(XFontPropertyType.loadFromStream(stream)); break;
				case 5: setAutoSize(XBooleanPropertyType.loadBFromStream(stream)); break;
				case 6: setParentColor(XBooleanPropertyType.loadBFromStream(stream)); break;
				case 7: setParentFont(XBooleanPropertyType.loadBFromStream(stream)); break;
				case 8: gauge.setFillColor(XColorPropertyType.loadFromStream(stream)); break;
				case 9: gauge.setKind(XIntegerPropertyType.loadFromStream(stream).intValue()); break;
				case 10: gauge.setShowText(XBooleanPropertyType.loadBFromStream(stream)); break;
				case 11: gauge.setBorderColor(XColorPropertyType.loadFromStream(stream)); break;
				case 12: gauge.setBorderWidth(XIntegerPropertyType.loadFromStream(stream).intValue()); break;
				case 13: gauge.setBorderStyle(XIntegerPropertyType.loadFromStream(stream).intValue()); break;
				case 14: gauge.setValue(XIntegerPropertyType.loadFromStream(stream).intValue()); break;
			}
		}

		for (int i = 0; i < eventCount; i++) {
			if (stream.readBoolean())
				parentForm.assignEvent(this, i, stream.readUTF());
		}
	}		
	
	public void saveToStream(DataOutput stream) throws IOException {

		super.saveToStream(stream);

		for (int i = 0; i < propertyCount; i++) {
			boolean b = propertyDefault(i);
			stream.writeBoolean(b);
			if (!b) {
				switch (i) {
					case 0: XColorPropertyType.saveToStream(gauge.getBackground(), stream); break;
					case 1: XColorPropertyType.saveToStream(gauge.getForeground(), stream); break;
					case 2: XBooleanPropertyType.saveToStream(gauge.isEnabled(), stream); break;
					case 3: XBooleanPropertyType.saveToStream(bVisible, stream); break;
					case 4: XFontPropertyType.saveToStream(gauge.getFont(), stream); break;
					case 5: XBooleanPropertyType.saveToStream(autoSize, stream); break;
					case 6: XBooleanPropertyType.saveToStream(parentColor, stream); break;
					case 7: XBooleanPropertyType.saveToStream(parentFont, stream); break;
					case 8: XColorPropertyType.saveToStream(gauge.getFillColor(), stream); break;
					case 9: XIntegerPropertyType.saveToStream(new Integer(gauge.getKind()), stream); break;
					case 10: XBooleanPropertyType.saveToStream(gauge.getShowText(), stream); break;
					case 11: XColorPropertyType.saveToStream(gauge.getBorderColor(), stream); break;
					case 12: XIntegerPropertyType.saveToStream(new Integer(gauge.getBorderWidth()), stream); break;
					case 13: XIntegerPropertyType.saveToStream(new Integer(gauge.getBorderStyle()), stream); break;
					case 14: XIntegerPropertyType.saveToStream(new Integer(gauge.getValue()), stream); break;
				}
			}
		}

		for (int i = 0; i < eventCount; i++) {
			if ((events[i] != null) && (events[i].length() > 0)) {
				stream.writeBoolean(true);
				stream.writeUTF(events[i]);
			}
			else stream.writeBoolean(false);
		}
	}
	
}