/**
* Xelfi
*/

package xelfi.design.components.xawt;

/**
  *
  * @version 	2.12, 03 Apr 1997
  * @author 	Petr Hamernik
  *
  */

import java.awt.*;
import java.io.*;
import xelfi.awt.Shape;
import xelfi.design.components.*;
import xelfi.design.components.property.*;
import xelfi.design.forms.XelfiDesignForm;
import xelfi.design.util.XFDesignConstants;
import xelfi.design.util.XFDesignOptions;
import xelfi.design.util.XFDesignUtils;

public class XShape extends XAWTPanel {
	private Shape shape;

	private static int propertyCount = 7;
	private Object propDef[];
	private boolean propDefSet = false;
	private static int eventCount = 2;
	private String events[] = new String[eventCount];
	protected static Image icon = null;
	
	public XShape() { 
		super(XAWTPanel.WITHOUT_DRAGBORDER);
		setComponent(shape = new Shape());
		propDef = new Object[propertyCount];
		for (int i=0; i<propertyCount; i++)
			propDef[i] = null;
		if (icon == null)
			icon = loadIcon("shape.gif");
	}

	protected void regenForm(int what) {
		if (parentForm != null)
			parentForm.regenerateCode(this, what);
	}

	public String[] neededImports() {
		String[] ret = new String[1];
		ret[0] = "xelfi.awt.Shape";
		return ret;
	}

	public Image getIcon() {
		return icon; 
	}

	private boolean propertyDefault(int i) throws XFPropertyIndexOutOfBoundsException {
		if (propDefSet)
			propertiesSetDefault();
		if (propDef[i] == null)
			return false;
		switch (i) {
			case 0: return (((Integer) propDef[i]).intValue() == shape.getShape());
			case 1: return (((Boolean) propDef[i]).booleanValue() == shape.isEnabled());
			case 2: return (((Boolean) propDef[i]).booleanValue() == bVisible);
			case 3: return (shape.defaultBorderColor.equals(shape.getBorderColor()));
			case 4: return (shape.defaultBorderWidth == shape.getBorderWidth());
			case 5: return (((Boolean) propDef[i]).booleanValue() == shape.getFill());
			case 6: return (shape.defaultFillColor.equals(shape.getFillColor()));
			default: throw new XFPropertyIndexOutOfBoundsException();
		}
	}

	private void propertiesSetDefault() {
		if (propDefSet)
			return;
		propDefSet = true;

		propDef[0] = new Integer(shape.defaultShape);
		propDef[1] = new Boolean(shape.isEnabled());
		propDef[2] = new Boolean(bVisible);
		propDef[3] = shape.defaultBorderColor;
		propDef[4] = new Integer(shape.defaultBorderWidth);
		propDef[5] = new Boolean(shape.getFill());
		propDef[6] = shape.defaultFillColor;
	}

	public int getPropertyCount() { return propertyCount; }
	
	public Object getProperty(int index) throws XFPropertyIndexOutOfBoundsException { 
		switch (index) {
			case 0: return new Integer(shape.getShape());
			case 1: return (shape.isEnabled()) ? Boolean.TRUE : Boolean.FALSE;
			case 2: return (bVisible) ? Boolean.TRUE : Boolean.FALSE;
			case 3: return shape.getBorderColor();
			case 4: return new Integer(shape.getBorderWidth());
			case 5: return (shape.getFill()) ? Boolean.TRUE : Boolean.FALSE;
			case 6: return shape.getFillColor();
			default: throw new XFPropertyIndexOutOfBoundsException();
		}
	}
			
	public String[] getPropertyNames() { 
		String list[] = new String[propertyCount];
		list[0] = "Shape";
		list[1] = "Enabled";
		list[2] = "Visible";
		list[3] = "Border Color";
		list[4] = "Border Width";
		list[5] = "Fill";
		list[6] = "Fill color";

		return list;
	}
		
	public String getPropertyString(int index) throws 
		XFPropertyIndexOutOfBoundsException { 
		switch (index) {
			case 1:
			case 2: return XBooleanPropertyType.viewString(getProperty(index));
			case 3: return XColorPropertyType.viewString(getProperty(index));
			case 4: return XIntegerPropertyType.viewString(getProperty(index));
			case 5: return XBooleanPropertyType.viewString(getProperty(index));
			case 6: return XColorPropertyType.viewString(getProperty(index));
			default: throw new XFPropertyIndexOutOfBoundsException();
		}
	}

	public int getPropertyViewerType(int index) throws 
		XFPropertyIndexOutOfBoundsException {
		switch (index) {
			case 0: return XFDesignConstants.PVT_CHOICE_STRICT;
			case 1:
			case 2: return XFDesignConstants.PVT_CHECK;
			case 3: return XFDesignConstants.PVT_SPECIAL;
			case 4: return XFDesignConstants.PVT_INPUT_INT;
			case 5: return XFDesignConstants.PVT_CHECK;
			case 6: return XFDesignConstants.PVT_SPECIAL;
			default: throw new XFPropertyIndexOutOfBoundsException();
		}
	}

	public String[] getPropertyValueNames(int index) throws 
		XFPropertyIndexOutOfBoundsException {
		switch (index) {
			case 0: String[] ret = new String[4];
					ret[0] = "Circle";
					ret[1] = "Elipse";
					ret[2] = "Rectangle";
					ret[3] = "Square";
					return ret;
			default: throw new XFPropertyIndexOutOfBoundsException();
		}
	}

	public Object[] getPropertyValueValues(int index) throws 
		XFPropertyIndexOutOfBoundsException {
		switch (index) {
			case 0: Integer[] ret = new Integer[4];
					ret[0] = new Integer(Shape.SHAPE_CIRCLE);
					ret[1] = new Integer(Shape.SHAPE_ELIPSE);
					ret[2] = new Integer(Shape.SHAPE_RECTANGLE);
					ret[3] = new Integer(Shape.SHAPE_SQUARE);
					return ret;
			default: throw new XFPropertyIndexOutOfBoundsException();
		}
	}

	public int setProperty(int index, Object value) throws 	
		XFPropertyIndexOutOfBoundsException,
		XFPropertyBadValueTypeException 
	{ 
		int ret = XFDesignConstants.RSP_OK;
		int regen = XFDesignConstants.GEN_SETPROPS;
		if (!propDefSet)
			propertiesSetDefault();
		switch (index) { 
			case 0:if (!(value instanceof Integer)) throw new XFPropertyBadValueTypeException();
					try {
						shape.setShape(((Integer)value).intValue());
					} catch (ArrayIndexOutOfBoundsException e) {
						System.out.println("Index out of bounds.");
					}
				 	ret = ret | XFDesignConstants.RSP_REPAINT_COMP;
					shape.repaint();
					break;					
			case 1:	if (!(value instanceof Boolean)) throw new XFPropertyBadValueTypeException();
					shape.enable(((Boolean)value).booleanValue());
					break;
			case 2: if (!(value instanceof Boolean)) throw new XFPropertyBadValueTypeException();
					bVisible = ((Boolean)value).booleanValue();
					break;
			case 3:if (!(value instanceof Color)) throw new XFPropertyBadValueTypeException();
					shape.setBorderColor((Color)value);
				 	ret = ret | XFDesignConstants.RSP_REPAINT_COMP;
					shape.repaint();
					break;
			case 4:if (!(value instanceof Integer)) throw new XFPropertyBadValueTypeException();
					shape.setBorderWidth(((Integer)value).intValue());
				 	ret = ret | XFDesignConstants.RSP_REPAINT_COMP;
					shape.repaint();
					break;
			case 5:	if (!(value instanceof Boolean)) throw new XFPropertyBadValueTypeException();
					shape.setFill(((Boolean)value).booleanValue());
				 	ret = ret | XFDesignConstants.RSP_REPAINT_COMP;
					shape.repaint();
					break;
			case 6:if (!(value instanceof Color)) throw new XFPropertyBadValueTypeException();
					shape.setFillColor((Color)value);
				 	ret = ret | XFDesignConstants.RSP_REPAINT_COMP;
					shape.repaint();
					break;
			default: throw new XFPropertyIndexOutOfBoundsException();
		}
		regenForm(regen);
		
		return ret;
	}
			
	public void specialPropertyInput(Frame parent, int index) throws 	
		XFPropertyIndexOutOfBoundsException, 
		XFPropertyNoSpecialInputException { 
		if ((index < 0) || (index >= propertyCount)) throw new XFPropertyIndexOutOfBoundsException();
		switch (index) { 
			case 3: 
			case 6: XColorPropertyType.invokeSpecialInput(parent, this, index);
					break;
			default: throw new XFPropertyNoSpecialInputException();
		}
	}

	public int getEventCount() {
		return eventCount;
	}

	public String[] getEventNames() {
		String list[] = new String[eventCount];
		list[0] = "OnGotFocus";
		list[1] = "OnLostFocus";
		return list;
	}

	public String getEvent(int index) throws 
		XFPropertyIndexOutOfBoundsException {
		if ((index>=0) && (index<eventCount)) {
			if (events[index] == null)
				return null;
			else
				return new String(events[index]); 
		}
		else throw new XFPropertyIndexOutOfBoundsException();
	}		
		
	public void setEvent(int index, String value) throws 
		XFPropertyIndexOutOfBoundsException {
		if ((index>=0) && (index<eventCount))
			events[index] = value;
		else throw new XFPropertyIndexOutOfBoundsException();
	}		

	public String getClassName() {
		return "Shape";
	}
	
	public String generateCode(int what) {
		String gen = "";
		switch (what) {
			case XFDesignConstants.GEN_VARIABLE: 
				gen = getClassName()+" "+ name + ";\n";
				break;
			case XFDesignConstants.GEN_INIT: 
				gen = name + " = new " + getClassName() + "();\n";
				break;
			case XFDesignConstants.GEN_SETPROPS:
				if (!propDefSet)
					propertiesSetDefault();
				for (int i = 0; i < propertyCount; i++) {
					if (!propertyDefault(i)) {
						switch(i) {
							case 0: gen = gen + name + ".setShape(Shape.SHAPE_";
									switch (shape.getShape()) {
										case Shape.SHAPE_CIRCLE: gen = gen + "CIRCLE"; break;
										case Shape.SHAPE_ELIPSE: gen = gen + "ELIPSE"; break;
										case Shape.SHAPE_RECTANGLE: gen = gen + "RECTANGLE"; break;
										case Shape.SHAPE_SQUARE: gen = gen + "SQUARE"; break;
									}
									gen = gen + ");\n";
									break;
							case 1: gen = gen + name + (shape.isEnabled() ? ".enable();\n" : ".disable();\n");
									break;
							case 2: gen = gen + name + ((bVisible) ? ".show();\n" : ".hide();\n");
									break;
							case 3: gen = gen + name + ".setBorderColor(" +
										XFDesignUtils.genColor(shape.getBorderColor()) + ");\n";
									break;
							case 4: gen = gen + name + ".setBorderWidth(" + shape.getBorderWidth() + ");\n";
									break;
							case 5: gen = gen + name + ".setFill(" + (shape.getFill() ? "true" : "false") + ");\n";
									break;
							case 6: gen = gen + name + ".setFillColor(" +
										XFDesignUtils.genColor(shape.getFillColor()) + ");\n";
									break;
						}
					}
				}
				break;			
			case XFDesignConstants.GEN_RESHAPE:
				if (((XelfiVisualContainer) getParent()).getDesignLayout().allowsDragging()) {
					if (!autoSize) 
						if (getParent() instanceof XelfiDesignForm)
							gen = name + ".reshape(insets.left+"+position.x+", insets.top+"+position.y+","+size.width+","+size.height+");\n";
						else 
							gen = name + ".reshape("+position.x+","+position.y+","+size.width+","+size.height+");\n";
					else {
						gen = name + ".resize(" + name + ".preferredSize());\n";
						if (getParent() instanceof XelfiDesignForm)
							gen = gen + name + ".move(insets.left+"+position.x+", insets.top+"+position.y+");\n";
						else
							gen = gen + name + ".move("+position.x+","+position.y+");\n";
					}
				}
				break;
		}
		return gen;
	}

	public String generateEventCondition(int index) throws XFPropertyIndexOutOfBoundsException {
		String evt = XFDesignOptions.eventVarName;
		switch (index) { 
			case 0: return evt +".id == Event.GOT_FOCUS && "+evt+".target == "+getName();
			case 1: return evt +".id == Event.LOST_FOCUS && "+evt+".target == "+getName();
			default: throw new XFPropertyIndexOutOfBoundsException();
		}
	}

	public boolean handleEvent(Event evt) {
		evt.target = this;
		return super.handleEvent(evt);
	}

	public void loadFromStream(DataInput stream) throws IOException {

		super.loadFromStream(stream);

		if (!propDefSet)
			propertiesSetDefault();

		for (int i = 0; i < propertyCount; i++) {
			if (stream.readBoolean())
				propDef[i] = null;
			else switch (i) {
				case 0: shape.setShape(XIntegerPropertyType.loadFromStream(stream).intValue()); break;
				case 1: shape.enable(XBooleanPropertyType.loadBFromStream(stream)); break;
				case 2: bVisible = XBooleanPropertyType.loadBFromStream(stream); break;
				case 3: shape.setBorderColor(XColorPropertyType.loadFromStream(stream)); break;
				case 4: shape.setBorderWidth(XIntegerPropertyType.loadFromStream(stream).intValue()); break;
				case 5: shape.setFill(XBooleanPropertyType.loadBFromStream(stream)); break;
				case 6: shape.setFillColor(XColorPropertyType.loadFromStream(stream)); break;
			}
		}

		for (int i = 0; i < eventCount; i++) {
			if (stream.readBoolean())
				parentForm.assignEvent(this, i, stream.readUTF());
		}
	}		
	
	public void saveToStream(DataOutput stream) throws IOException {

		super.saveToStream(stream);

		for (int i = 0; i < propertyCount; i++) {
			boolean b = propertyDefault(i);
			stream.writeBoolean(b);
			if (!b) {
				switch (i) {
					case 0: XIntegerPropertyType.saveToStream(new Integer(shape.getShape()), stream); break;
					case 1: XBooleanPropertyType.saveToStream(shape.isEnabled(), stream); break;
					case 2: XBooleanPropertyType.saveToStream(bVisible, stream); break;
					case 3: XColorPropertyType.saveToStream(shape.getBorderColor(), stream); break;
					case 4: XIntegerPropertyType.saveToStream(new Integer(shape.getBorderWidth()), stream); break;
					case 5: XBooleanPropertyType.saveToStream(shape.getFill(), stream); break;
					case 6: XColorPropertyType.saveToStream(shape.getFillColor(), stream); break;
				}
			}
		}

		for (int i = 0; i < eventCount; i++) {
			if ((events[i] != null) && (events[i].length() > 0)) {
				stream.writeBoolean(true);
				stream.writeUTF(events[i]);
			}
			else stream.writeBoolean(false);
		}
	}
	
}