/**
* Xelfi
*/

package xelfi.design.forms;

import java.awt.Color;
import xelfi.editor.*;
import xelfi.design.util.XFDesignOptions;

/**
* This class does the coloring of guarded blocks in editor
*
* @version 	1.02, 27 Feb 1997
* @author 	Ian Formanek
*/

public class DesignBackgroundCallback implements BackgroundCallback {
	BlockContainer bc; // user blocks in a form

	DesignBackgroundCallback(BlockContainer aBc) {
		bc = aBc;
	}
	
	/**
	* @see BackgroundCallback#getBackground
	*/
	public Color getBackground (Position p) {
		Block b = null;
		try {
			b = bc.find(p, Block.BEGIN | Block.INSIDE);
		} catch (java.util.NoSuchElementException e) {
			return XFDesignOptions.GuardedBlockBackground;
		}
		return null;
	}

	/**
	* @see BackgroundCallback#getForeground
	*/
	public Color getForeground () {
		return null;
	}
}
