/**
* Xelfi
*/

package xelfi.design.forms;

import java.awt.*;
import java.util.Vector;
import xelfi.design.components.*;
import xelfi.design.util.*;

/**
* @version 	1.06, 23 Feb 1997
* @author 		Ian Formanek
*/

class XFGen {
	static String generateVariables(XelfiDesignForm form) {
		String gen = "";
		Vector comps = form.getAllComponents();
		int count = comps.size();
		for (int i=1; i<count; i++) // it is from 1 because we exclude the form itself
			gen = addText(gen, XFDesignOptions.indent(1),
								((XelfiDesignComponent)comps.elementAt(i)).generateCode(XFDesignConstants.GEN_VARIABLE));
		gen = gen+"\n";
		return gen;
	}
				
	static String generateComponents(XelfiDesignForm form) {
		String gen = "";
		Vector comps = form.getAllComponents();
		int count = comps.size();

		for (int i=1; i<count; i++) { // it is from 1 because we exclude the form itself
			XelfiDesignComponent xdc = (XelfiDesignComponent)comps.elementAt(i);
			XelfiVisualContainer xvcont;
			if (xdc instanceof XelfiVisualComponent)
				xvcont = (XelfiVisualContainer)((Component)xdc).getParent();
			else
				xvcont = (XelfiVisualContainer)form;
				
			XelfiDesignLayout xdl = xvcont.getDesignLayout();
			
			gen = addText(gen, XFDesignOptions.indent(2), xdc.generateCode(XFDesignConstants.GEN_INIT));
			if (xdc instanceof XelfiVisualContainer)
				gen = addText(gen, XFDesignOptions.indent(2), xdc.generateCode(XFDesignConstants.GEN_SETLAYOUT));
			gen = addText(gen, XFDesignOptions.indent(2), xdc.generateCode(XFDesignConstants.GEN_SETPROPS));
			if (xdc instanceof XelfiVisualComponent)
				if (xvcont instanceof XelfiDesignForm) 
					gen = addText(gen, XFDesignOptions.indent(2), xdl.genComponentLayoutCode(null, (XelfiVisualComponent)xdc, null)); // [PENDING - variable name]
				else 
					gen = addText(gen, XFDesignOptions.indent(2), xdl.genComponentLayoutCode(xvcont.getName(), (XelfiVisualComponent)xdc, null)); // [PENDING - variable name]
		}
		return gen;
	}

	static String addText(String toWhat, String indent, String what) {
		if ((what == null) || (what.equalsIgnoreCase(""))) return toWhat;
		what = XFDesignUtils.adjustIndent(what, indent);
		return toWhat + what;
	}
	
}