/**
* Xelfi
*/

package xelfi.design.forms.layouts;

import java.io.DataInput;
import java.io.DataOutput;
import java.io.IOException;
import java.awt.Frame;
import java.awt.Container;
import java.awt.Component;
import xelfi.design.components.*;
import xelfi.design.forms.AbsoluteLayout;
import xelfi.design.util.XFDesignConstants;

/* XAbsoluteLayout is design layout class for absolute positioning.
 * It has no properties.
 * It is here only for generating some (small) code for null layout.
 * @version 	1.17, 31 Mar 1997 (From 1.10 extends AbsoluteLayout)
 * @author 	Ian Formanek
 */

public class XAbsoluteLayout extends AbsoluteLayout implements XelfiDesignLayout {
		
	private XelfiVisualContainer parent;
	public void setParent(XelfiVisualContainer aParent) {
		parent = aParent;
	}

	public int getPropertyCount() { return 0;}
	public String[] getPropertyNames() { return null; }

	public void addComponent(XelfiVisualComponent comp) {
	}
	public void renameComponent(XelfiVisualComponent comp, String newName) throws 
		XFNameNotFoundException {
	}
	public void removeComponent(XelfiVisualComponent comp) throws 
		XFNameNotFoundException {
	}

	public int getPropertyViewerType(int index) throws 
		XFPropertyIndexOutOfBoundsException {
		throw new XFPropertyIndexOutOfBoundsException();
	}

	public String[] getPropertyValueNames(int index) throws 
		XFPropertyIndexOutOfBoundsException {
		throw new XFPropertyIndexOutOfBoundsException();
	}

	public Object[] getPropertyValueValues(int index) throws 
		XFPropertyIndexOutOfBoundsException {
		throw new XFPropertyIndexOutOfBoundsException();
	}

	public Object getProperty(XelfiVisualComponent comp, int index) throws 
		XFPropertyIndexOutOfBoundsException,
		XFNameNotFoundException {
		throw new XFPropertyIndexOutOfBoundsException();
	}
		
	public String getPropertyString(XelfiVisualComponent comp, int index) throws 
		XFPropertyIndexOutOfBoundsException,
		XFNameNotFoundException {
		throw new XFPropertyIndexOutOfBoundsException();
	}
		
	public int setProperty(XelfiVisualComponent comp, int index, Object value) throws 
		XFPropertyIndexOutOfBoundsException,
		XFPropertyBadValueTypeException,
		XFNameNotFoundException {
		throw new XFPropertyIndexOutOfBoundsException();
	}

	public void specialPropertyInput(Frame parent, XelfiVisualComponent comp, int index) throws 
		XFPropertyIndexOutOfBoundsException,
		XFPropertyNoSpecialInputException,
		XFNameNotFoundException {
		throw new XFPropertyIndexOutOfBoundsException();
	}
		
	public String getClassName() {
		return "Absolute Positioning";
	}

	///////////////////
	// Layout things //
	///////////////////

	public boolean allowsDragging() { return true; }

	public void layoutAdd(Container cont, XelfiVisualComponent comp) {
		cont.add((Component)comp);
	}

	public void layoutAdd(Container cont, int pos, XelfiVisualComponent comp) {
		cont.add((Component)comp, pos);
	}
	
	/////////////////////
	// Code generation //
	/////////////////////
	
	public String[] neededImports() {
		String list[] = new String[0];
		return list;
	}

	// this method returns whether it needs a variable for the layout
	public boolean genLayoutVariable() { return false; }
		
	public String genLayoutInitCode(String containerName, String varName) {
		if (containerName == null)
			return "setLayout(null);\n"+
			       "addNotify();\n"+
			       "Insets insets = insets();\n"; 
			// the insets variable is used by components to add form border to its position,
			// so that the component is placed on right position
		else 
			return containerName+".setLayout(null);\n";
	}
	
	public String genComponentLayoutCode(String containerName, XelfiVisualComponent comp, String varName) {
		if (containerName == null)
			return "add("+comp.getName()+");\n"+comp.generateCode(XFDesignConstants.GEN_RESHAPE);
		else 
			return containerName+".add("+comp.getName()+");\n"+comp.generateCode(XFDesignConstants.GEN_RESHAPE);
	}
	
	/////////////////
	// Persistence //
	/////////////////

	public void loadFromStream(DataInput stream) throws
		IOException { }
	
	public void saveToStream(DataOutput stream) throws
		IOException { }

}	