/**
* The xelfi Editor
*/

package xelfi.editor;

/**
* One record for undo the insert action. Has method how to revert to previous state.
*
* @version 1.0
* @author Jaroslav Tulach
*/

class UndoInsert extends UndoEvent {
  /** insert has been done from position from */
  private Position from;
  /** till till position end */
  private Position end;

  /** New object.
  * @param f begin position
  * @param e the end position
  */
  public UndoInsert (Position f, Position e) {
    from = f;
    end = e;
  }
  
  /** Undoes the event.
  * @return the position of undo
  */
  public Position undo () {
    try {
      from.deleteTill (end, null);
      return end;
    } catch (NotAllowedException ex) {
      return null;
    }
  }
}


