/**
* Xelfi Environment
*/

package xelfi.editor.actions;
import xelfi.editor.*;
import xelfi.editor.keys.*;
import java.util.Vector;

/** Places new bookmark. This command must be followed by one string
* parameter.
*
* @author Jaroslav Tulach
* @version 1.0
*/
public class PlaceBookmark extends Object implements KeyActionHandler {
  /** name of the bookmark */
  String name;

  /** Initialize the object.
  * @param v vector of parameters. It can contain objects of type
  *   String, Integer, Character.
  * @exception IllegalArgumentException if a parameter is not valid
  */
  public void init (Vector v) {
    try {
      if (v.size () == 1) {
        name = (String)v.elementAt (0);
        return;
      };
    } catch (Exception ex) {
    };
    throw new IllegalArgumentException ("Expecting one string parameter");
   };

  /** Inserts the key to the editor.
  * @param key the key code that occured
  * @param modifiers the state of modifiers
  * @param info info about editor
  * @return true if next command should be excecuted, false if
  *   the action should stop
  * @exception NotAllowedException if the action is not allowed
  */
  public boolean keyDown (int key, int modifiers, TextEditorInfo info)
  throws NotAllowedException {
    TextEditorOperation.placeBookmark (info, name);
    return true;
  };
}







