package xelfi.execution;

import java.awt.*;
import java.applet.*;

class AppletViewer extends Frame
{
  private Applet app;
  AppletViewer(String[] arg, Applet ap)
  {
    super("Applet " + arg[0]);
    app = ap;

    Dimension bounds;
    if(arg.length < 3) bounds = null;
    else
    {
      bounds = new Dimension();
      try
      {
        bounds.width = Integer.valueOf(arg[1]).intValue();
        bounds.height = Integer.valueOf(arg[2]).intValue();
      } catch (NumberFormatException ex) { bounds = null; }
    }

    setLayout(new BorderLayout());
    add ("Center", app);
    if(getPeer() != null) addNotify();
    System.out.println(bounds);
    if(bounds != null) resize(insets().left + insets().right + bounds.width,
      insets().top + insets().bottom + bounds.height);
    else pack();
    show ();

//    Runnable r = (Runnable)o;

    app.init();
    app.start();
  }

    // arg 0 - applet class name
    // arg 1 - width
    // arg 2 - height
  public static void main (String[] arg) throws Exception
  {
    Object o = Class.forName(arg[0]).newInstance ();
    if (!(o instanceof java.applet.Applet))
    {
      System.err.println("AppletViewwer: Can't view " + arg[0] + " .");
      System.err.println("The class is not an Applet.");
      System.err.flush();
      System.exit(1);
    }
    new AppletViewer(arg, (Applet)o).show();
  }


  public boolean handleEvent(Event event)
  {
    if(event.target == this && event.id == Event.WINDOW_DESTROY)
    {
      app.stop();
      app.destroy();
      System.exit(0);
      return true;
    }
    return super.handleEvent(event);
  }

  public Insets insets()   // Under JDK 1.0.2 for win95 insets doesnt work. This patch should help.
  {
    Insets i = super.insets();
    if(getPeer() != null && (i.top < 0 || i.bottom < 0 || i.left < 0 || i.right < 0))
      return new Insets(28, 4, 4, 4);
    else return i;
  }
}






