/** Row and Col layout manager properties base.
* @author: Filip Dvorak
* @version: 1.0
*/

package xelfi.top.visual;

import java.awt.*;

  /** Base class for RowLayoutProperties and ColayoutProperties. */
public class LayoutPropertiesBase implements Cloneable
{
    /** These insets are amount of extra space around a component. */
  public Insets compInsets;

    /** These values have a bit different meaning in RowLayoutProperties and ColayoutProperties. */
  public float compGrowth, topSpaceGrowth, bottomSpaceGrowth, rightSpaceGrowth, leftSpaceGrowth;

  public LayoutPropertiesBase()
  {
    compInsets = new Insets(0, 0, 0, 0);
    compGrowth = topSpaceGrowth = bottomSpaceGrowth = rightSpaceGrowth = leftSpaceGrowth = 0;
  }

  public LayoutPropertiesBase(Insets i)
  {
    compInsets = i;
    compGrowth = topSpaceGrowth = bottomSpaceGrowth = rightSpaceGrowth = leftSpaceGrowth =  0;
  }

  public LayoutPropertiesBase(float componentGrowth)
  {
    compInsets = new Insets(0, 0, 0, 0);
    compGrowth = componentGrowth;
    topSpaceGrowth = bottomSpaceGrowth = rightSpaceGrowth = leftSpaceGrowth = 0;
  }

  public LayoutPropertiesBase(Insets i, float componentGrowth)
  {
    compInsets = i;
    compGrowth = componentGrowth;
    topSpaceGrowth = bottomSpaceGrowth = rightSpaceGrowth = leftSpaceGrowth = 0;
  }

  public Object clone()
  {
	try
	{
	  LayoutPropertiesBase clon = (LayoutPropertiesBase) super.clone();
      clon.compInsets = (Insets)compInsets.clone();
      return clon;
    }
    catch (CloneNotSupportedException e) // this shouldn't happen, since we are Cloneable
    {
      throw new InternalError();
    }
  }
}
