/**
* Xelfi
*/

package xelfi.util;

/**
 * @version 	1.05, 24 Feb 1997
 * @author 	Ian Formanek
 */

public class Debug {
	public static final int ERROR = 0;
	public static final int FORMIO_LOAD = 1;
	public static final int FORMIO_SAVE = 2;
	public static final int FORM = 4;
	public static final int INSPECTOR = 8;
	public static final int EDITOR = 16;
	public static final int BROWSER = 32;
	public static final int DEBUGGER = 64;
	public static final int COMPILER = 128;
	public static final int PROPIO_LOAD = 256;
	public static final int PROPIO_SAVE = 512;
	public static final int LAYOUTS = 1024;
	public static final int MENU = 2048;

	public static final int ALL = 4095;

	private static int filter = ALL;
	private static boolean debugging = false;
	
	public static void debug(String msg) {
		if (debugging)
			System.out.println(msg);
	}
	
	public static void debug(int debug_code, String msg) {
		if (debugging && ((filter & debug_code) != 0))
			System.out.println(msg);
	}
	
	public static void setDebugging(boolean aDebugging) {
		debugging = aDebugging;
	}
	
	public static void setDebugging(boolean aDebugging, int aFilter) {
		debugging = aDebugging;
		filter = aFilter;
	}

	public static boolean getDebugging() {
		return debugging;
	}

	public static void setFilter(int aFilter) {
		filter = aFilter;
	}

	public static int getFilter() {
		return filter;
	}
	
	public static void debugException(Exception e) {
		System.err.println(e.getMessage());
		e.printStackTrace(System.err);
	}
}